//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//********************************** ADC  demo code   **********************************//
//********************************** reference the note  **********************************//
//*****************volt_AN is the voltage of the AN input voltage*************************//
//*****************AD convert result is the 8 data average value *************************//
//*****************************************************************************************//

#include <CMS/CMS8S3660.H>

//***************define constant******************//

#define 		volt_VBG	1200
#define			ADCH		0x0B5				//enable&clock&convert EX channel
#define			ADVBG		0x0BF				//enable&clock&convert internal channel
#define			NUM_AN		5
//*******************variable*********************//

bit F_ADC;
u8	ADCH_SW;
long result_ADC_VBG,result_ADC_CH;
long volt_AN;

//*******************initial*********************//

void ADC_init();								//ADC function initinal
void INT_init();								//interrupt initial
void ADC_INT();									//F_ADC:converter over;

//******************* main  *********************//

void main()
{
	int i=0,j=0;
	long MAX_ADC_CH,MIN_ADC_CH,SUM_ADC_CH;
	
	P3UP=0xFF;
	ADC_init();									//ADC function initinal 
	INT_init();									//interrupt initinal
	
	while(1)
	{
		clrwdt();

//******volt_AN is the voltage of the input channel*****//
//******the data divide 1000 is the real voltage *******//
		
		if(ADCON1==ADCH)
		{
			for(i=0;i<10;i++)
			{
				
				ADCON0			|= 0x02;				//start AD converter
				
				while(F_ADC==0)
				{
					if(0 == (--j))
						return;
				}				
				if(F_ADC)
				{
					result_ADC_CH	= (ADRESH<<8)+ADRESL;//read the convert result
					F_ADC			= 0;
				
				if(i==0)
				{
					MAX_ADC_CH		= result_ADC_CH;
					MIN_ADC_CH		= result_ADC_CH;
					SUM_ADC_CH		= 0;
				}
				if(result_ADC_CH>MAX_ADC_CH)
				{
					MAX_ADC_CH		= result_ADC_CH;	//catch the MAX convert data
				}
				if(result_ADC_CH<MAX_ADC_CH)
				{
					MIN_ADC_CH		= result_ADC_CH;	//catch the MIN convert data
				}
				
					SUM_ADC_CH		+= result_ADC_CH;	//read the SUM data 
				}
				
			}
				result_ADC_CH	= (SUM_ADC_CH-MAX_ADC_CH-MIN_ADC_CH)>>3;
				ADCON1			= ADVBG;					//AN channel switch

		}
		else
		{
			
			for(i=0;i<10;i++)
			{
				
				ADCON0			|= 0x02;				//start AD converter
				
				while(F_ADC==0)
				{
					if(0 == (--j))
						return;
				}				
				if(F_ADC)
				{
					result_ADC_VBG	= (ADRESH<<8)+ADRESL;//read the convert result
					F_ADC			= 0;
				
				if(i==0)
				{
					MAX_ADC_CH		= result_ADC_VBG;
					MIN_ADC_CH		= result_ADC_VBG;
					SUM_ADC_CH		= 0;
				}
				if(result_ADC_CH>MAX_ADC_CH)
				{
					MAX_ADC_CH		= result_ADC_VBG;	//catch the MAX convert data
				}
				if(result_ADC_CH<MAX_ADC_CH)
				{
					MIN_ADC_CH		= result_ADC_VBG;	//catch the MIN convert data
				}
					SUM_ADC_CH		+= result_ADC_VBG;	//read the SUM data 
				}					
			}	
			
				result_ADC_VBG	= (SUM_ADC_CH-MAX_ADC_CH-MIN_ADC_CH)>>3;
			
				volt_AN			= (result_ADC_CH*volt_VBG)/result_ADC_VBG;
				//the volteage of the AN channel,the value divide 1000
			
				ADCON1			= ADCH;					//AN channel switch
		}	
	}
}


/*************************************************
function name: ADC_init()
function work: initial the ADC function
input data   : null
output data  : null
note		 : setting the ADC function
*************************************************/
void ADC_init()
{

	#define		pin0	0x01;
	#define		pin1	0x02;
	#define		pin2	0x04;
	#define		pin3	0x08;

	#define		pin4	0x10;
	#define		pin5	0x20;
	#define		pin6	0x40;
	#define		pin7	0x80;	
	
//=======e.g. if use AN0+AN3,in the sample port THE value is pin0+pin3========//	

//	P0TRIS		&=	~pin4;		// input mode
//	P04CFG		=	0x01;

	P0TRIS		&=	~pin5;		// input mode
	P05CFG		=	0x01;

//	P1TRIS		&=	~pin3;		// input mode 
//	P13CFG		=	0x01;

//	P1TRIS		&=	~pin4;		// input mode 
//	P14CFG		=	0x01;

//	P2TRIS		&=	~pin2;		// input mode
//	P22CFG		=	0x01;

//	P2TRIS		&=	~pin3;		// input mode
//	P23CFG		=	0x01;

//	P2TRIS		&=	~pin4;		// input mode
//	P24CFG		=	0x01;

//	P2TRIS		&=	~pin5;		// input mode
//	P25CFG		=	0x01;

//	P2TRIS		&=	~pin6;		// input mode
//	P26CFG		=	0x01;

//	P3TRIS		&=	~pin1;		// input mode
//	P31CFG		=	0x01;

//	P3TRIS		&=	~pin2;		// input mode
//	P32CFG		=	0x01;

//	P3TRIS		&=	~pin5;		// input mode
//	P35CFG		=	0x01;

//	P3TRIS		&=	~pin6;		// input mode
//	P36CFG		=	0x01;

//	P1TRIS		&=	~pin5;		// input mode
//	P15CFG		=	0x01;

//	P1TRIS		&=	~pin6;		// input mode
//	P16CFG		=	0x01;

//	P1TRIS		&=	~pin7;		// input mode
//	P17CFG		=	0x01;

//	P2TRIS		&=	~pin1;		// input mode
//	P21CFG		=	0x01;

//	P2TRIS		&=	~pin0;		// input mode
//	P30CFG		=	0x01;


//==============other register configure=====================//

	ADCON2		=	0x00;
	
	//bit7 0:disable HW trigger 1:enable HW trigger
	//bit6 0:external trigger pin selected ADCET0	1:external trigger pin selected ADCET1
	//bit5~4 ADC HW trigger source select 
	//		 00:PG0(PWM0)	01:PG2 (PWM2)	10:PG4 (PWM4)	11:ADCET0/ADCET1	
	//bit3~2 ADC HW trigger edge select
	//		 00:falling edge 01:rising edge 10:PWM period middle 11:PWM period end

	ADCON1		=	ADCH;		
	
	//bit7 	0:disable ADC IP  1:enable ADC IP
	//bit6~4:ADCKS<2:0> ADC clock select
	// 		000:f/2	001:f/4	010:f/8	011:f/16	100:f/32 101:f/64 110:f/128 111:f/256
	//bit3~0:ADCHS<3:0>: AN channel select
	//0000~1110:AN0~AN14		1111:AN15	reference for ADCON0.AN15SEL define
	
	if(NUM_AN<0x10)
	{
		ADCON0		=	0x40;
	}
	else
	{
		ADCON0		=	0x80;
	}
	
	//bit7 1: AN channel>=16 0: AN channel<16
	//bit6 0:left align	1:right align
	//bit5~4 AN15 select source bit 	00:VBG 01:OP0_O 10:OP1_O
	//bit1 ADGO 	0:can not write 1:start AD converter
	
	ADCMPC		=	0x00;
	
	//bit7 0:disable ADC CMP pwm fb function 1:enable 
	//bit6 0:ADRES>=ADCMP,ADCMPO=1;1:ADRES<ADCMP,ADCMPO=1
	//bit4 ADC CMP output bit 0:CMP output 0 1:CMP output 1
	//bit1~0 ADC HW trigger delay time bit9~8
	
	ADDLYL		=	0x00;
	
	//ADC HW trigger delay time bit7~0
	
	//the ADC result 
	//ADRESH/ADRESL
	//ADFM=0 ADRESH:ADRES11~ADRES4 ADRESL7~4:ADRES3~ADRES0
	//ADFM=1 ADRESH3~0:ADRES11~ADRES8 ADRESL:ADRES7~ADRES0
	
	//the CMP register
	//ADCMPH:D11~D4 ADCMPL BIT3~0:D3~D0
	
//	ADCON0		|=	0x02;			//start AD converter
	
//*****************************************************************//	
	
}

/*************************************************
function name: INT_init()
function work: initial the INT function
input data   : null
output data  : null
note		 : setting the interrupt function
*************************************************/
void INT_init()						//intterrupt initinal
{
	IE		=	0x00;
	
//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
//Bit6	ES1	UART1 interrupt enable bit  0:disable 1:enable
//Bit5	ET2	Timer2 global interrupt enable bit  0:disable 1:enable
//Bit4	ES0	UART0 interrupt enable bit  0:disable 1:enable
//Bit3	ET1	Timer1 interrupt enable bit  0:disable 1:enable
//Bit2	EX1	INT1 interrupt enable bit  0:disable 1:enable
//Bit1	ET0	Timer0 interrupt enable bit  0:disable 1:enable
//Bit0	EX0	INT0 interrupt enable bit  0:disable 1:enable

	EIE2	=	0x10;
	
//Bit7	SPIIE	SPI enable interrupt bit 0:disable 1:enable
//Bit6	I2CIE	I2C enable interrupt bit 0:disable 1:enable
//Bit5	WDTIE	WDT enable interrupt bit 0:disable 1:enable
//Bit4	ADCIE	ADC enable interrupt bit 0:disable 1:enable
//Bit3	PWMIE	PWM enable interrupt bit 0:disable 1:enable(EIP2.PPWM must be the same as EIP1.PP3PWM)
//Bit1	ET4	 Timer4 enable interrupt bit 0:disable 1:enable
//Bit0	ET3	 Timer3 enable interrupt bit 0:disable 1:enable
 	
	EIP2	=	0x00;
	
//Bit7	PSPI	SPI interrupt priority control bit 0:high priority 1:low priority
//Bit6	PI2C	I2C interrupt priority control bit 0:high priority 1:low priority
//Bit5	PWDT	WDT interrupt priority control bit 0:high priority 1:low priority
//Bit4	PADC	ADC interrupt priority control bit 0:high priority 1:low priority
//Bit3	PPWM	PWM interrupt priority control bit 0:high priority 1:low priority
//Bit1	PT4  Timer4 interrupt priority control bit 0:high priority 1:low priority
//Bit0	PT3  Timer3 interrupt priority control bit 0:high priority 1:low priority


	EA		=	1;		//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
	
}


/*************************************************
function name: ADC_INT()
function work: ADC INT sub function
input data   : null
output data  : null
note		 : interrupt function and set the flag
*************************************************/
void ADC_INT()		interrupt	ADC_VECTOR	
{
	EIF2		&=	0xEF;
	F_ADC		=	1;
		
}
