#include <CMS/CMS8S3660.H>

//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//********************************** I2C slave receive&send********************************//
//************************** receive data and then send data*******************************//
//*****************************************************************************************//

//***********define constant*********//

#define			bit_run		0x01				//I2CMCR.0 run   bit 0:disable 1:enable(transmit&receive)
#define			bit_start	0x02				//I2CMCR.1 start bit 0:disable 1:enable
#define			bit_stop	0x04				//I2CMCR.2 stop  bit 0:disable 1:enable
#define			bit_ack		0x08				//I2CMCR.3 ACK   bit 0:disable 1:enable

#define		MAIN_CLOCK_FREQ		16000000uL		//unit:Hz

//*******************variable*********************//

u8	RECEx[4];
u8	i,temp;

//*******************initial*********************//

void I2C_SR_init();								//slave
void INT_init();								//INT initinal

//*******************MAIN*********************//

void main()
{
	i=0;
	
	I2C_SR_init();
	INT_init();
	
	while(1)
	{
		clrwdt();
		if(i==4)
		{
			if(I2CSCR==0x02)
			{
			I2CSBUF	= temp++;
			I2CMCR	= 0x01;
			}
		}
	
	}
	
	
	
	
}
/*************************************************
function name: I2C_SR_init()
function work: initial the I2C slave function
input data   : null
output data  : null
note		 : setting the I2C slave function
*************************************************/
void I2C_SR_init()
{
#define			Addr_Slave		0x50
	
	P04CFG		=	0x03;						//switch P04 to SCL
	P05CFG		=	0x03;						//switch P05 to SDA
	FUNCCR		&=	0xEF;						//SCL,SDA for I2C pin	
	P0TRIS 		&= 	0xCF; 						//intput mode
//	P0OD		|=	0x30;						//ver1.1 add opendrain output setting
	
//	
//	FUNCCR		|=	0x10;						//[SCL],[SDA]for I2C pin
//	P21CFG		=	0x03;
//	P35CFG		=	0x03;

//	P2TRIS		&=	0xFD;
//	P3TRIS		&=	0xDF;						//input mode

//	P2OD		|=	0x02;						//ver1.1 add opendrain output setting
//	P3OD		|=	0x20;						//ver1.1 add opendrain output setting	
	
	I2CSADR		=	Addr_Slave;
	
	//I2C slave address
	
	I2CSCR		=	0x01;
	
	//bit7 I2C slave reset control bit 0:disable 1:reset slave 
	//bit0 I2C slave mode enable bit 0:disable 1:enable 
}

/*************************************************
function name: INT_init()
function work: initial the INT function
input data   : null
output data  : null
note		 : setting the interrupt function
*************************************************/
void INT_init()						//interrupt initinal
{

	EIE2	=	0x40;
	
//Bit7	SPIIE	SPI enable interrupt bit 0:disable 1:enable
//Bit6	I2CIE	I2C enable interrupt bit 0:disable 1:enable
//Bit5	WDTIE	WDT enable interrupt bit 0:disable 1:enable
//Bit4	ADCIE	ADC enable interrupt bit 0:disable 1:enable
//Bit3	PWMIE	PWM enable interrupt bit 0:disable 1:enable(EIP2.PPWM must be the same as EIP1.PP3PWM)
//Bit1	ET4	 Timer4 enable interrupt bit 0:disable 1:enable
//Bit0	ET3	 Timer3 enable interrupt bit 0:disable 1:enable
  	
	EIP2	=	0x00;
	
//Bit7	PSPI	SPI interrupt priority control bit 0:high priority 1:low priority
//Bit6	PI2C	I2C interrupt priority control bit 0:high priority 1:low priority
//Bit5	PWDT	WDT interrupt priority control bit 0:high priority 1:low priority
//Bit4	PADC	ADC interrupt priority control bit 0:high priority 1:low priority
//Bit3	PPWM	PWM interrupt priority control bit 0:high priority 1:low priority
//Bit1	PT4  Timer4 interrupt priority control bit 0:high priority 1:low priority
//Bit0	PT3  Timer3 interrupt priority control bit 0:high priority 1:low priority


	EA		=	1;		//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
	
}
/*************************************************
function name: I2C_INT()
function work: I2C INT function
input data   : null
output data  : null
note		 : send and receive the data
*************************************************/
void I2C_INT()		interrupt	I2C_VECTOR
{
	if(EIF2&0x40)
	{		
		if(I2CSCR==0x01)						//slave receive data
		{

			RECEx[i]	= I2CSBUF;				//slave read data
			
			I2CMCR		= 0x09;
				i++; 
		}
	}
}