//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//********************************** timer2  capture data**********************************//
//********************************** reference the note  **********************************//
//*****************************************************************************************//

#include <CMS/CMS8S3660.H>

//***********define constant*********//

//*******************variable*********************//

long TM2_CNT=0;
long C_CNT1=0;
long C_CNT2=0;
long CAP_CNT=0;

bit	F_first=0;
bit F_final=0;

//*******************initial*********************//

void TM2ICx_init();								//capture initinal
void T2INT_init();
void TM2_INT();

//*********************MAIN***********************//

void main()
{
	
	TM2ICx_init();								//Timer2 capture setting
	T2INT_init();								//timer2 int initinal
	
//	DATA_capture();								//Timer2 capture data

	P1TRIS		&= 0xF7;						//setting p13 input
	P1UP		|= 0x08;
	T2IF 		&= 0x7F;						//clear the overflow flag
	
	while(1)
	{
		clrwdt();
		
		if(F_final)
		{
			F_final=0;
			
			if(TM2_CNT==0)
			{
				CAP_CNT=C_CNT2-C_CNT1;
			}
			else
			{
				CAP_CNT=C_CNT2+65536*TM2_CNT-C_CNT1;
			}
			
			RLDH		=	0x00;
			RLDL		=	0x00;
			
			TH2			=	0x00;
			TL2			=	0x00;	
			
			C_CNT1	= 0;
			C_CNT2	= 0;
			TM2_CNT	= 0;
			
		}
	}
}

/*************************************************
function name: TM2ICx_init()
function work: initial the timer2 capture function
input data   : null
output data  : null
note		 : setting the timer2 capture initial 
*************************************************/
void TM2ICx_init()								//timer2 capture function
{
	T2CON		=	0x51;
	
	//bit7 Timer2 clock prescaler 0:fsys/12 1:fsys/24
	//bit6 interrupt edge capture mode 1:rising capture  0:falling capture
	//					  compara mode 1:rising intterrupt 0:falling intterrupt
	//bit5 capture edge selected 0:rising edge 1:falling edge
	//bit4~3 T2R1-T2R0:timer2 reload mode
	//        0x:disable reload 10:reload mode1 timer2 overflow reload 11:reload mode2 T2EX falling reload
	//bit2 T2CM compare mode selected  1:compare mode1 0:compare mode0
	//bit1~0 timer2 clock input select bit 00:timer2 disable 01:fsys prescaler 10/11:reserved
	
	CCEN		=	0x01;
	
	//bit7~6 CMH3-CML3 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch3 rising edge trigger 10:compare mode 11:capture in write CCL3 trigger
	//bit5~4 CMH2-CML2 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch2 rising edge trigger 10:compare mode 11:capture in write CCL2 trigger
	//bit3~2 CMH1-CML1 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch1 rising edge trigger 10:compare mode 11:capture in write CCL1 trigger
	//bit1~0 CMH0-CML0 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch0 rising/falling edge trigger 10:compare mode 11:capture in write CCL0 trigger
	
	CAPCR0		=	0x00;
	
	//bit7~4 CAP0CR7-CAP0CR4 capture ch1 input select bit
	//  0000~1000:IC0~IC8 others:IC0
	//bit3~0 CAP0CR3-CAP0CR0 capture ch0 input select bit
	//  0000~1000:IC0~IC8 others:IC0

	CAPCR1		=	0x00;
	
	//bit7~4 CAP0CR7-CAP0CR4 capture ch3 input select bit
	//  0000~1000:IC0~IC8 others:IC0
	//bit3~0 CAP0CR3-CAP0CR0 capture ch2 input select bit
	//  0000~1000:IC0~IC8 others:IC0

	RLDH		=	0x00;
	RLDL		=	0x00;
	
	//capture/compare/reload register
	
//	CCH1		=	0x00;
//	CCL1		=	0x00;
//	CCH2		=	0x00;
//	CCL2		=	0x00;
//	CCH3		=	0x00;
//	CCL3		=	0x00;
	//timer2 compare/capture ch1/2/3 register
	
	TH2			=	0x00;
	TL2			=	0x00;

	//TIMER2 initial value
}



void T2INT_init()
{
	
	IE		=	0x20;
	
//Bit7	EA	Global interrupt enable bit 0:disable 1:enable
//Bit6	ES1	UART1 interrupt enable bit  0:disable 1:enable
//Bit5	ET2	Timer2 global interrupt enable bit  0:disable 1:enable
//Bit4	ES0	UART0 interrupt enable bit  0:disable 1:enable
//Bit3	ET1	Timer1 interrupt enable bit  0:disable 1:enable
//Bit2	EX1	INT1 interrupt enable bit  0:disable 1:enable
//Bit1	ET0	Timer0 interrupt enable bit  0:disable 1:enable
//Bit0	EX0	INT0 interrupt enable bit  0:disable 1:enable
	
	T2IE	=	0x81;

//Bit7	T2OVIE	timer2 overflow int enable 0:disable 1:enable
//Bit6	T2EXIE	timer2 external reload int enable 0:disable 1:enable
//Bit3	T2C3IE	timer2 capture CH3 int enable 0:disable 1:enable
//Bit2	T2C2IE	timer2 capture CH2 int enable 0:disable 1:enable
//Bit1	T2C1IE	timer2 capture CH1 int enable 0:disable 1:enable
//Bit0	T2C0IE	timer2 capture CH0 int enable 0:disable 1:enable
	
	T2IF	=	0x00;

//Bit7	TF2	timer2 overflow flag 0:timer2 no overflow 1: timer2 overflow 
//Bit6	T2EXIF	timer2 external reload flag 0:-- 1: timer2 T2EX falling trigger,must software clear 
//Bit3  T2C3IF	timer2 compare/capture flag 0:-- 1: Timer2 Compare Channel 3 {CCH3:CCL3}={TH2:TL2} or Capture Channel 3 produces capture operations, requiring software clear
//Bit2  T2C2IF	timer2 compare/capture flag 0:-- 1: Timer2 Compare Channel 2 {CCH2:CCL2}={TH2:TL2} or Capture Channel 2 produces capture operations, requiring software clear
//Bit1  T2C1IF	timer2 compare/capture flag 0:-- 1: Timer2 Compare Channel 1 {CCH1:CCL1}={TH2:TL2} or Capture Channel 1 produces capture operations, requiring software clear
//Bit0  T2C0IF	timer2 compare/capture flag 0:-- 1: Timer2 Compare Channel 0 {CCH0:CCL0}={TH2:TL2} or Capture Channel 0 produces capture operations, requiring software clear

	EA		=	1;
	
}

void	TM2_INT()	interrupt	TIMER2_VECTOR
{
	if((T2IF&0x80)==0x80)
	{
		T2IF&=0x07f;
		
		if(F_first)
		{
			TM2_CNT++;
		}
	}
	
	if(T2IF&0x01==0x01)
	{
		T2IF&=0x0fe;
		
		if(F_first==0)
		{
			C_CNT1	=	(RLDL+(RLDH<<8));
			
			F_first	=	1;
		}
		else
		{
			C_CNT2	=	(RLDL+(RLDH<<8));
			
			F_first	=	0;
			F_final	=	1;
		}
	}
	
	T2IF	=	0x00;
	
}
	