//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//********************************** timer2  PWM FUNCTION*******************************//
//********************************** CC1 CC2 CC3 output pwm*********************************//
//*****************************************************************************************//

#include <CMS/CMS8S3660.H>

//***********define constant*********//

	#define		pin0	0x01;
	#define		pin1	0x02;
	#define		pin2	0x04;
	#define		pin3	0x08;

	#define		pin4	0x10;
	#define		pin5	0x20;
	#define		pin6	0x40;
	#define		pin7	0x80;
//*******************variable*********************//


//*******************initial*********************//

void TM2_PWM();								//capture initinal

//*********************MAIN***********************//

void main()
{

	P3TRIS		|=	0x40;		// output mode
	P36CFG		=	0x03;	
	
	TM2_PWM();								//Timer2 capture setting

	while(1)
	{		
		clrwdt();
	}
	
}

void TM2_PWM()
{

 //GPIO setting
//	P3TRIS		|=	pin6;		// output mode
//	P36CFG		=	0x03;

	P2TRIS		|=	pin4;		// output mode
	P24CFG		=	0x03;

	P2TRIS		|=	pin3;		// input mode
	P23CFG		=	0x03;

	P2TRIS		|=	pin2;		//output mode
	P22CFG		=	0x03;
	
	P1TRIS		|=	pin3;		//output mode
	P1_3		=	1;
	
	T2CON		=	(0x011+0x00);    //  Fsc/12      compare
	//bit7 Timer2 clock prescaler 0:fsys/12 1:fsys/24
	//bit6 interrupt edge capture mode 1:rising capture  0:falling capture
	//					  compara mode 1:rising intterrupt 0:falling intterrupt
	//bit4~3 T2R1-T2R0:timer2 reload mode
	//        0x:disable reload 10:reload mode1 timer2 overflow reload 11:reload mode2 T2EX falling reload
	//bit2 T2CM compare mode selected  1:compare mode1 0:compare mode0  //mode 1 only for CC3
	//bit1~0 timer2 clock input select bit 00:timer2 disable 01:fsys prescaler 10/11:reserved
	
	CCEN		=	0xa8 ;     //CC1 CC3 enable
	
	//bit7~6 CMH3-CML3 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch3 rising edge trigger 10:compare mode 11:capture in write CCL3 trigger
	//bit5~4 CMH2-CML2 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch2 rising edge trigger 10:compare mode 11:capture in write CCL2 trigger
	//bit3~2 CMH1-CML1 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch1 rising edge trigger 10:compare mode 11:capture in write CCL1 trigger
	//bit1~0 CMH0-CML0 compare/capture mode control bit
	//	00:compare/capture mode disbale 01:capture in ch0 rising/falling edge trigger 10:compare mode 11:capture in write CCL0 trigger
	
	CAPCR0		=	0x00;
	
	//bit7~4 CAP0CR7-CAP0CR4 capture ch1 input select bit
	//  0000~1000:IC0~IC8 others:IC0
	//bit3~0 CAP0CR3-CAP0CR0 capture ch0 input select bit
	//  0000~1000:IC0~IC8 others:IC0

	CAPCR1		=	0x00;
	
	//bit7~4 CAP0CR7-CAP0CR4 capture ch3 input select bit
	//  0000~1000:IC0~IC8 others:IC0
	//bit3~0 CAP0CR3-CAP0CR0 capture ch2 input select bit
	//  0000~1000:IC0~IC8 others:IC0

	RLDH		=	0xff;//0x7f;
	RLDL		=	0x37;
	
	//capture/compare/reload register
	
	CCH1		=	0xff;
	CCL1		=	0x60;
	
	CCH2		=	0xff;
	CCL2		=	0x90;
	
	CCH3		=	0xff;
	CCL3		=	0xc0;
	//timer2 compare/capture ch1/2/3 register
	
	TH2			=	0x00;
	TL2			=	0x00;





}

